;Acetronic Chess Traveller

;specifications from instructions:
;Fairchild 3870, 4,000,000 cycles/sec, 2,048 bytes program size, 320 bytes RAM
;8 skill levels, 200mA, 6 AA batteries, external 7.5V 2.5mm positive tip

;actually measured about 3MHz clock, and 3870 divides that by 2 internally

;3870 labeled SL90387
;3539 256x8 static RAM - addr bus on port 0, data bus on port 4
;75492 LED driver
;4-digit 7-segment LED display, common cathode

;3870 Port assignment summary					
;Port0	RAM addr bus				
;Port1	LED segments: ABCDEFGx
;Port4	RAM data bus				
;Port5	switch rows&columns, LED digits				
; Col2 Col3 Col4 Col1 Row4 Row3 Row2 Row1
;   x    x    x    x  LED1 LED2 LED3 LED4
					
;keyboard matrix and LED digits					
;         Port5-4   Port5-7   Port5-6        Port5-5	
;Port5-0   A/1        CE        LV        E/5 & digit 4
;Port5-1   B/2        ENT       FP        F/6 & digit 3
;Port5-2   C/3        MM        EP        G/7 & digit 2
;Port5-3   D/4        x         New       H/8 & digit 1				

Reset:          LISU 2                   ; 0000 62
                LISL 1                   ; 0001 69
                LIS  $1                  ; 0002 71
                LR   (IS)+,A             ; 0003 5d
                LR   (IS),A              ; 0004 5c
                LISL 7                   ; 0005 6f
                LIS  $0                  ; 0006 70
                LR   (IS),A              ; 0007 5c
                
                LISU 4                   ; 0008 64		;"New" key hit
                LISL 4                   ; 0009 6c
                LIS  $0                  ; 000a 70
                LR   (IS),A              ; 000b 5c
                LISU 3                   ; 000c 63
                LISL 1                   ; 000d 69
                LI   $40                 ; 000e 20 40
                LR   (IS)+,A             ; 0010 5d
                LIS  $0                  ; 0011 70
                LR   (IS)+,A             ; 0012 5d
                LIS  $f                  ; 0013 7f
                LR   (IS)+,A             ; 0014 5d
                PI   A0040               ; 0015 28 00 40
                LI   $1d                 ; 0018 20 1d
                LR   $0,A                ; 001a 50
                DCI  A0060               ; 001b 2a 00 60
A001e:          LR   A,$0                ; 001e 40
                OUTS 0                   ; 001f b0		;RAM address bus
                LR   H,DC                ; 0020 11
                LIS  $0                  ; 0021 70
                AM                       ; 0022 88
                BT   4,A0069             ; 0023 84 45
                
                OUTS 4                   ; 0025 b4		;RAM data bus
                INS  0                   ; 0026 a0		;RAM address bus
                AI   $0a                 ; 0027 24 0a
                OUTS 0                   ; 0029 b0		;RAM address bus
                LI   $41                 ; 002a 20 41	;pawns
                OUTS 4                   ; 002c b4		;RAM data bus
                INS  0                   ; 002d a0		;RAM address bus
                AI   $32                 ; 002e 24 32
                OUTS 0                   ; 0030 b0		;RAM address bus
                LI   $81                 ; 0031 20 81	;pawns
                OUTS 4                   ; 0033 b4		;RAM data bus
                INS  0                   ; 0034 a0		;RAM address bus
                AI   $0a                 ; 0035 24 0a
                OUTS 0                   ; 0037 b0		;RAM address bus
                LR   DC,H                ; 0038 10
                LM                       ; 0039 16
                XI   $c0                 ; 003a 23 c0
                OUTS 4                   ; 003c b4		;RAM data bus
                DS   $0                  ; 003d 30
                BF   $0,A001e            ; 003e 90 df
                
A0040:          LIS  $0                  ; 0040 70
                OUTS 0                   ; 0041 b0		;RAM address bus
A0042:          LI   $c0                 ; 0042 20 c0
                OUTS 4                   ; 0044 b4		;RAM data bus
                INS  0                   ; 0045 a0		;RAM address bus
                INC                      ; 0046 1f
                OUTS 0                   ; 0047 b0		;RAM address bus
                BT   1,A0042             ; 0048 81 f9
                
                LI   $1d                 ; 004a 20 1d
                LR   $0,A                ; 004c 50
                LIS  $8                  ; 004d 78
                LR   $2,A                ; 004e 52
A004f:          LR   A,$0                ; 004f 40
                OUTS 0                   ; 0050 b0		;RAM address bus
A0051:          LIS  $0                  ; 0051 70
                OUTS 4                   ; 0052 b4		;RAM data bus
                INS  0                   ; 0053 a0		;RAM address bus
                AI   $0a                 ; 0054 24 0a
                OUTS 0                   ; 0056 b0		;RAM address bus
                CI   $64                 ; 0057 25 64
                BT   1,A0051             ; 0059 81 f7
                
                DS   $0                  ; 005b 30
                DS   $2                  ; 005c 32
                BF   $4,A004f            ; 005d 94 f1
                
                POP                      ; 005f 1c

A0060:
				db   $44,$42,$43,$46,$45,$43,$42,$44	;DCI here from 001B - weights of back row pieces
				db   $00
				
A0069:          PI   A023d               ; 0069 28 02 3d
A006c:          PI   A01d6               ; 006c 28 01 d6		;get a key
                CI   $08                 ; 006f 25 08			;is it grid key or command key?
                BT   1,A00c0             ; 0071 81 4e			;jump if grid key
                
                AI   $f7                 ; 0073 24 f7			;subtract 9 to make 0-6
                DCI  A007f               ; 0075 2a 00 7f		;command jump table
                ADC                      ; 0078 8e				
                ADC                      ; 0079 8e
                LM                       ; 007a 16
                LR   QU,A                ; 007b 06
                LM                       ; 007c 16
                LR   QL,A                ; 007d 07
                LR   P0,Q                ; 007e 0d				;jump to command
                
A007f:									;command jump table
                db   $00,$8d            ;LV
                db   $00,$e9			;FP
                db   $01,$48			;EP
                db   $00,$08			;New
                db   $00,$69			;CE
                db   $02,$7c			;Enter
                db   $00,$e1			;MM

                LISU 2                   ; 008d 62				;LV key hit - set level
                LISL 1                   ; 008e 69
                LR   A,(IS)              ; 008f 4c
                LR   $4,A                ; 0090 54
                
A0091:          LISU 2                   ; 0091 62
                LISL 3                   ; 0092 6b
                LI   $1c                 ; 0093 20 1c
                LR   (IS)+,A             ; 0095 5d
                LIS  $2                  ; 0096 72
                LR   (IS)+,A             ; 0097 5d
                LR   (IS)+,A             ; 0098 5d
                LR   A,$4                ; 0099 44
                DCI  NUMBERS             ; 009a 2a 02 66
                ADC                      ; 009d 8e
                LM                       ; 009e 16
                LR   (IS),A              ; 009f 5c
A00a0:          PI   A01d6               ; 00a0 28 01 d6	;get a key
                CI   $08                 ; 00a3 25 08
                BT   1,A00b5             ; 00a5 81 0f	;1-8 hit, set level
                
                CI   $0d                 ; 00a7 25 0d	;CE
                BT   4,A0069             ; 00a9 84 bf
                
                CI   $0e                 ; 00ab 25 0e	;not ENTER
                BF   $4,A0091            ; 00ad 94 e3
                
                LISU 2                   ; 00af 62
                LISL 1                   ; 00b0 69
                LR   A,$4                ; 00b1 44
                LR   (IS),A              ; 00b2 5c
                BF   $0,A0069            ; 00b3 90 b5
                
A00b5:          LR   $4,A                ; 00b5 54		;set level
                BF   $0,A0091            ; 00b6 90 da
                
A00b8:          LI   $ca                 ; 00b8 20 ca
                LR   $0,A                ; 00ba 50
                PI   A0249               ; 00bb 28 02 49
                BF   $0,A006c            ; 00be 90 ad
                
A00c0:          LR   $8,A                ; 00c0 58			;grid key (A/1-H8) hit
                PI   A023d               ; 00c1 28 02 3d
                LISL 3                   ; 00c4 6b
                DCI  A00cc               ; 00c5 2a 00 cc
                LR   Q,DC                ; 00c8 0e
                JMP  A0204               ; 00c9 29 02 04

A00cc:          LR   $7,A                ; 00cc 57			DCI here from 00C5 - return address, not data
                PI   A01ef               ; 00cd 28 01 ef
                LR   $9,A                ; 00d0 59
                PI   A01d6               ; 00d1 28 01 d6	;get a key
                CI   $0d                 ; 00d4 25 0d		;CE
                BT   4,A0069             ; 00d6 84 92
                
                CI   $0e                 ; 00d8 25 0e		;not enter
                BF   $4,A00b8            ; 00da 94 dd
                
                LR   A,$7                ; 00dc 47
                LR   $8,A                ; 00dd 58
                JMP  A027f               ; 00de 29 02 7f
                
                LISU 2                   ; 00e1 62		;MM key hit
                LISL 2                   ; 00e2 6a
                LIS  $1                  ; 00e3 71
                XS   (IS)                ; 00e4 ec
                LR   (IS),A              ; 00e5 5c
                JMP  A0069               ; 00e6 29 00 69
                
A00e9:          LI   $41                 ; 00e9 20 41	;FP key hit
A00eb:          LR   $5,A                ; 00eb 55
                LI   $15                 ; 00ec 20 15
                LR   $4,A                ; 00ee 54
A00ef:          LIS  $0                  ; 00ef 70
                OUTS 0                   ; 00f0 b0		;RAM address bus
                OUTS 4                   ; 00f1 b4		;RAM data bus
A00f2:          LISU 2                   ; 00f2 62
                LISL 3                   ; 00f3 6b
A00f4:          LR   A,$4                ; 00f4 44
                CI   $64                 ; 00f5 25 64
                BT   4,A0126             ; 00f7 84 2e
                
                INC                      ; 00f9 1f
                LR   $4,A                ; 00fa 54
                OUTS 0                   ; 00fb b0		;RAM address bus
                INS  4                   ; 00fc a4		;RAM data bus
                XS   $5                  ; 00fd e5
                BF   $4,A00f4            ; 00fe 94 f5
                
                PI   A0250               ; 0100 28 02 50
A0103:          LI   $8e                 ; 0103 20 8e
                LR   (IS)+,A             ; 0105 5d
                LI   $ce                 ; 0106 20 ce
                LR   (IS)+,A             ; 0108 5d
                PI   A01d6               ; 0109 28 01 d6	;get a key
                CI   $06                 ; 010c 25 06	;<=6?
                BT   1,A012e             ; 010e 81 1f
                
                AI   $f9                 ; 0110 24 f9	;subtract 7 to get 0-8
                DCI  A011d               ; 0112 2a 01 1d
                ADC                      ; 0115 8e
                LM                       ; 0116 16		;get offset from table
                DCI  $0189               ; 0117 2a 01 89
                ADC                      ; 011a 8e		;add offset to $0189
                LR   Q,DC                ; 011b 0e
                LR   P0,Q                ; 011c 0d		;jump
                
A011d:			db   $b1				;$23a
				db	 $b7				;$240
				db   $80				;$209
				db   $80				;$209
				db   $bf				;$248
				db   $80				;$209
				db   $21				;$1aa
				db   $21				;$1aa
				db   $80                ;$209

A0126:          LIS  $2                  ; 0126 72
                LR   (IS)+,A             ; 0127 5d
                LR   (IS)+,A             ; 0128 5d
                LI   $15                 ; 0129 20 15
                LR   $4,A                ; 012b 54
                BF   $0,A0103            ; 012c 90 d6
                
A012e:          LR   $6,A                ; 012e 56
                LIS  $7                  ; 012f 77
                NS   $5                  ; 0130 f5
                XS   $6                  ; 0131 e6
                BT   4,A00ef             ; 0132 84 bc
                
                LR   A,$5                ; 0134 45
                NI   $f0                 ; 0135 21 f0
                AS   $6                  ; 0137 c6
                BF   $0,A00eb            ; 0138 90 b2
                
                LIS  $7                  ; 013a 77
                NS   $5                  ; 013b f5
                OI   $40                 ; 013c 22 40
                BF   $0,A00eb            ; 013e 90 ac
                
                LIS  $7                  ; 0140 77
                NS   $5                  ; 0141 f5
                OI   $80                 ; 0142 22 80
A0144:          BF   $0,A00eb            ; 0144 90 a6

                BF   $0,A00e9            ; 0146 90 a2
                
A0148:          LISU 3                   ; 0148 63	;EP key hit
                LISL 1                   ; 0149 69
                LR   A,(IS)+             ; 014a 4d
                LR   $5,A                ; 014b 55
                LIS  $0                  ; 014c 70
                LR   (IS)+,A             ; 014d 5d
                PI   A023d               ; 014e 28 02 3d
                LISL 5                   ; 0151 6d
                LI   $9e                 ; 0152 20 9e
                LR   (IS)+,A             ; 0154 5d
                LI   $ce                 ; 0155 20 ce
                LR   (IS)+,A             ; 0157 5d
                PI   A01d6               ; 0158 28 01 d6	;get a key
                CI   $06                 ; 015b 25 06	;<=6
                BT   1,A0191             ; 015d 81 33
                
                AI   $f9                 ; 015f 24 f9	;subtract 7 to get 0-8
                DCI  A016c               ; 0161 2a 01 6c
                ADC                      ; 0164 8e
                LM                       ; 0165 16		;get offset from table
                DCI  A01c6               ; 0166 2a 01 c6
                ADC                      ; 0169 8e		;add offset to $1c6
                LR   Q,DC                ; 016a 0e
                LR   P0,Q                ; 016b 0d		;jump
                
A016C:
				db   $bd					;$283
				db $c4						;$28a
				db $c8						;$28e
				db $80						;$246
				db $82						;$248
				db $af						;$275
				db $e4						;$2aa
				db $e4						;$2aa
				db $82						;$248
				db $28						;$1ee
				db $00						;$1c6
				db $40						;$206
				
                LISU 4                   ; 0178 64
                LISL 4                   ; 0179 6c
                LI   $3c                 ; 017a 20 3c
                
                LR   (IS),A              ; 017c 5c
                LISU 3                   ; 017d 63
                LISL 3                   ; 017e 6b
                LIS  $0                  ; 017f 70
                LR   (IS),A              ; 0180 5c
                BF   $0,A0148            ; 0181 90 c6
                
                LI   $40                 ; 0183 20 40
                
A0185:          LISU 3                   ; 0185 63
                LISL 1                   ; 0186 69
                LR   (IS),A              ; 0187 5c
                BF   $0,A0148            ; 0188 90 bf
                
                LI   $80                 ; 018a 20 80
                BF   $0,A0185            ; 018c 90 f8
                
                LIS  $0                  ; 018e 70
                BF   $0,A0192            ; 018f 90 02
                
A0191:          AS   $5                  ; 0191 c5
A0192:          LR   $5,A                ; 0192 55
                LISU 2                   ; 0193 62
                LISL 3                   ; 0194 6b
                PI   A01ef               ; 0195 28 01 ef
                LR   $4,A                ; 0198 54
                PI   A01d6               ; 0199 28 01 d6	;get a key
                CI   $0e                 ; 019c 25 0e		;ENTER
                BF   $4,A0148            ; 019e 94 a9
                
                LR   A,$4                ; 01a0 44
                LR   $3,A                ; 01a1 53
                OUTS 0                   ; 01a2 b0		;RAM address bus
                LR   A,$5                ; 01a3 45
                OUTS 4                   ; 01a4 b4		;RAM data bus
                PI   A06ea               ; 01a5 28 06 ea
                BF   $0,A0148            ; 01a8 90 9f
                
A01aa:          JMP  A0069               ; 01aa 29 00 69

A01ad:          LISU 2                   ; 01ad 62
                LISL 3                   ; 01ae 6b
                DCI  A0277               ; 01af 2a 02 77
A01b2:          LM                       ; 01b2 16
                OUTS 5                   ; 01b3 b5		;LED digits
                LIS  $0                  ; 01b4 70
                AS   (IS)+               ; 01b5 cd
                OUTS 1                   ; 01b6 b1		;LED segments
                BT   4,A01bf             ; 01b7 84 07
                
                LIS  $0                  ; 01b9 70
A01ba:          INC                      ; 01ba 1f
                BF   $4,A01ba            ; 01bb 94 fe
                
                BF   $0,A01b2            ; 01bd 90 f4
                
A01bf:          LI   $10                 ; 01bf 20 10	;emu: display LEDs here, get key entry if called from 1DA
                LR   $1,A                ; 01c1 51		;store $10 in reg1 - this is decremented and will be the result
                
                LIS  $f                  ; 01c2 7f		;row mask
                OUTS 5                   ; 01c3 b5		;set all rows high
                INS  5                   ; 01c4 a5		;read cols
                LR   $0,A                ; 01c5 50		;store in reg0
                
A01c6:          LI   $f0                 ; 01c6 20 f0	;col mask
                OUTS 5                   ; 01c8 b5		;set all cols high
                INS  5                   ; 01c9 a5		;read rows
                NS   $0                  ; 01ca f0		;and with cols
                DCI  A022e               ; 01cb 2a 02 2e	;key table
A01ce:          DS   $1                  ; 01ce 31		;reg1--
                BT   4,A01d4             ; 01cf 84 04	;checked all entries in key table?
                
                CM                       ; 01d1 8d		;look for match between rows/cols read and key table
                BF   $4,A01ce            ; 01d2 94 fb	;no match, keep looking
                
A01d4:          LR   A,$1                ; 01d4 41		;put match into Acc, 0 means not found
                POP                      ; 01d5 1c
                
A01d6:          LR   K,P                 ; 01d6 08		;emu: clear r16 here so key input works correctly
A01d7:          LISU 4                   ; 01d7 64		;is R33 a random #?  it gets decremented here in a loop
                LISL 1                   ; 01d8 69
                DS   (IS)                ; 01d9 3c		
                PI   A01ad               ; 01da 28 01 ad	;update display and read keys
                LISL 0                   ; 01dd 68
                XS   (IS)                ; 01de ec			;this is R16 because of LISU 2 at $1AD
                BT   4,A01d7             ; 01df 84 f7		;if same key as last, read again - what allows keypresses eg A followed by 1?  It's the same key twice.  something should clear R16
                
                LR   A,$1                ; 01e1 41
                LR   (IS),A              ; 01e2 5c
                PI   A01ad               ; 01e3 28 01 ad	;update display and read keys
                LISL 0                   ; 01e6 68
                XS   (IS)                ; 01e7 ec
                BF   $4,A01d7            ; 01e8 94 ee		;if 2 key reads are different, loop
                
                LIS  $0                  ; 01ea 70			;if no button, loop; emu: clear button down here
                AS   $1                  ; 01eb c1
                BT   4,A01d7             ; 01ec 84 ea
                
                PK                       ; 01ee 0c
                
A01ef:          LR   K,P                 ; 01ef 08
                LR   A,KU                ; 01f0 00
                LR   QU,A                ; 01f1 06
                LR   A,KL                ; 01f2 01
                LR   QL,A                ; 01f3 07
                LR   A,IS                ; 01f4 0a
                LR   $9,A                ; 01f5 59
                PI   A01d6               ; 01f6 28 01 d6	;get a key
                CI   $0d                 ; 01f9 25 0d		;CE
                BT   4,A01aa             ; 01fb 84 ae
                
                CI   $08                 ; 01fd 25 08		;
                BF   $1,A022b            ; 01ff 91 2b		;jump if command
                
                LR   $8,A                ; 0201 58			;A/1-H/8 hit
A0202:          LR   A,$9                ; 0202 49
                LR   IS,A                ; 0203 0b
A0204:          LR   A,$8                ; 0204 48
                DCI  LETTERS             ; 0205 2a 02 6e
                ADC                      ; 0208 8e
                LM                       ; 0209 16
                LR   (IS)+,A             ; 020a 5d
                LR   A,IS                ; 020b 0a
                LR   $9,A                ; 020c 59
                PI   A01d6               ; 020d 28 01 d6	;get a key
                CI   $0d                 ; 0210 25 0d		;CE
                BT   4,A01aa             ; 0212 84 97
                
                CI   $08                 ; 0214 25 08		;
                BF   $1,A022b            ; 0216 91 14		;jump if command
                
                DCI  NUMBERS             ; 0218 2a 02 66
                ADC                      ; 021b 8e
                LR   $0,A                ; 021c 50
                SL   1                   ; 021d 13
                SL   1                   ; 021e 13
                AS   $0                  ; 021f c0
                SL   1                   ; 0220 13
                AS   $8                  ; 0221 c8
                AI   $0b                 ; 0222 24 0b
                LR   $8,A                ; 0224 58
                LR   A,$9                ; 0225 49
                LR   IS,A                ; 0226 0b
                LM                       ; 0227 16
                LR   (IS)+,A             ; 0228 5d
                LR   A,$8                ; 0229 48
                LR   P0,Q                ; 022a 0d		return
                
A022b:          JMP  A00b8               ; 022b 29 00 b8

A022E:										;keyboard input row/col bits
				db   $84	;MM  = $0f
				db   $82	;ENT = $0e
				db   $81	;CE  = $0d
				db   $48    ;New = $0c
				db   $44	;EP  = $0b
				db   $42	;FP  = $0a
				db   $41	;LV  = $09
				db   $28	;H/8 = $08
				db   $24	;G/7 = $07
				db   $22	;F/6 = $06
				db   $21	;E/5 = $05
				db   $18	;D/4 = $04
				db   $14	;C/3 = $03
				db   $12	;B/2 = $02
				db   $11	;A/1 = $01
				                
A023d:          LI   $30                 ; 023d 20 30
                LR   $0,A                ; 023f 50
                LISU 3                   ; 0240 63
                LISL 1                   ; 0241 69
                LIS  $0                  ; 0242 70
                AS   (IS)                ; 0243 cc
                BT   1,A0249             ; 0244 81 04
                
                LI   $84                 ; 0246 20 84
                LR   $0,A                ; 0248 50
A0249:          LISU 2                   ; 0249 62
                LISL 3                   ; 024a 6b
                LR   A,$0                ; 024b 40
A024c:          LR   (IS)+,A             ; 024c 5d
                BR7  A024c               ; 024d 8f fe
                POP                      ; 024f 1c
                
A0250:          LIS  $0                  ; 0250 70
                LR   $0,A                ; 0251 50
                LR   A,$4                ; 0252 44
A0253:          DS   $0                  ; 0253 30
                AI   $f6                 ; 0254 24 f6
                BT   1,A0253             ; 0256 81 fc
                
                DCI  A0277               ; 0258 2a 02 77
                ADC                      ; 025b 8e
                LM                       ; 025c 16
                LR   (IS)+,A             ; 025d 5d
                LR   A,$0                ; 025e 40
                COM                      ; 025f 18
                DCI  A0265               ; 0260 2a 02 65
                ADC                      ; 0263 8e
                LM                       ; 0264 16
A0265:          LR   (IS)+,A             ; 0265 5d

NUMBERS:        POP                      ; 0266 1c			DCI here from 009A, 0218, and 0294
				db   $60,$DA,$F2,$66,$B6,$BE,$E0			;LED segments for numbers 1 2 3 4 5 6 7...
LETTERS:
				db   $fe									;... and 8
				db   $EE,$3E,$9c,$7a,$9e,$8e,$bc,$6e		;LED segments for letters A B C D E F G H

A0277:			db   $f7,$fb,$fd,$fe,$ff					;LED digit masks - low nibble, inverted
                
A027c:          LIS  $0                  ; 027c 70		;Enter key hit
                LR   $8,A                ; 027d 58
                LR   $9,A                ; 027e 59
A027f:          LISU 4                   ; 027f 64
                LISL 0                   ; 0280 68
                LIS  $0                  ; 0281 70
                LR   (IS),A              ; 0282 5c
                
                LISU 5                   ; 0283 65
                LR   (IS),A              ; 0284 5c
                LISU 3                   ; 0285 63
                LISL 4                   ; 0286 6c
                LR   (IS)+,A             ; 0287 5d
                LI   $7f                 ; 0288 20 7f
                
                LR   (IS)+,A             ; 028a 5d
                LI   $81                 ; 028b 20 81
                LR   (IS)+,A             ; 028d 5d
                
                LISU 2                   ; 028e 62
                LISL 1                   ; 028f 69
                LI   $fe                 ; 0290 20 fe
                OUTS 5                   ; 0292 b5		;LED digits
                LR   A,(IS)              ; 0293 4c
                DCI  NUMBERS             ; 0294 2a 02 66
                ADC                      ; 0297 8e
                LM                       ; 0298 16
                OUTS 1                   ; 0299 b1		;LED segments
                LIS  $2                  ; 029a 72
                AS   (IS)-               ; 029b ce
                LISU 3                   ; 029c 63
                LR   QL,A                ; 029d 07
                SR   1                   ; 029e 12
                LR   (IS),A              ; 029f 5c
                LR   A,QL                ; 02a0 03
                NI   $01                 ; 02a1 21 01
                SL   1                   ; 02a3 13
                INC                      ; 02a4 1f
                AS   (IS)-               ; 02a5 ce
                LR   (IS),A              ; 02a6 5c
A02a7:          LIS  $0                  ; 02a7 70
                OUTS 0                   ; 02a8 b0		;RAM address bus
                OUTS 4                   ; 02a9 b4		;RAM data bus
                LISU 4                   ; 02aa 64
                LISL 6                   ; 02ab 6e
                LR   (IS),A              ; 02ac 5c
                LISU 3                   ; 02ad 63
                LISL 4                   ; 02ae 6c
                LR   A,(IS)              ; 02af 4c
                LISL 0                   ; 02b0 68
                COM                      ; 02b1 18
                AS   (IS)                ; 02b2 cc
                BT   1,A02de             ; 02b3 81 2a
                
                LISU 4                   ; 02b5 64
                LISL 6                   ; 02b6 6e
                DS   (IS)                ; 02b7 3c
                LISU 3                   ; 02b8 63
                LR   A,(IS)              ; 02b9 4c
                COM                      ; 02ba 18
                INC                      ; 02bb 1f
                LISU 4                   ; 02bc 64
                LISL 0                   ; 02bd 68
                AS   (IS)                ; 02be cc
                BF   $8,A02c5            ; 02bf 98 05
                
                BT   1,A02db             ; 02c1 81 19
                
                BF   $0,A02c7            ; 02c3 90 03
                
A02c5:          BF   $1,A02db            ; 02c5 91 15

A02c7:          LR   A,(IS)              ; 02c7 4c
                LISU 3                   ; 02c8 63
                LISL 6                   ; 02c9 6e
                LR   (IS),A              ; 02ca 5c
                LISL 5                   ; 02cb 6d
                LR   A,(IS)+             ; 02cc 4d
                COM                      ; 02cd 18
                INC                      ; 02ce 1f
                AS   (IS)                ; 02cf cc
                BF   $8,A02d6            ; 02d0 98 05
                
                BT   1,A02db             ; 02d2 81 08
                
                BF   $0,A02d8            ; 02d4 90 03
                
A02d6:          BF   $1,A02db            ; 02d6 91 04

A02d8:          JMP  A055e               ; 02d8 29 05 5e

A02db:          JMP  A0351               ; 02db 29 03 51

A02de:          DCI  A07c0               ; 02de 2a 07 c0
                LISL 1                   ; 02e1 69
                LIS  $0                  ; 02e2 70
                AS   (IS)                ; 02e3 cc
                BT   1,A02e9             ; 02e4 81 04
                
                DCI  A07d9               ; 02e6 2a 07 d9
A02e9:          LIS  $0                  ; 02e9 70
                AM                       ; 02ea 88
                BF   $4,A02f0            ; 02eb 94 04
                
                JMP  A0320               ; 02ed 29 03 20
                
A02f0:          LISU 3                   ; 02f0 63
                LISL 3                   ; 02f1 6b
                NS   (IS)                ; 02f2 fc
                LM                       ; 02f3 16
                LR   $2,A                ; 02f4 52
                LR   H,DC                ; 02f5 11
                BF   $4,A02fd            ; 02f6 94 06
                
A02f8:          LR   A,$2                ; 02f8 42
                LR   DC,H                ; 02f9 10
                ADC                      ; 02fa 8e
                BF   $0,A02e9            ; 02fb 90 ed
                
A02fd:          LIS  $0                  ; 02fd 70
                AM                       ; 02fe 88
                BT   4,A0307             ; 02ff 84 07
                
                OUTS 0                   ; 0301 b0		;RAM address bus
                INS  4                   ; 0302 a4		;RAM data bus
                BF   $4,A02f8            ; 0303 94 f4
                
                BF   $0,A02fd            ; 0305 90 f7
                
A0307:          LIS  $0                  ; 0307 70
                AM                       ; 0308 88
                BT   4,A0313             ; 0309 84 09
                
                LR   $4,A                ; 030b 54
                PI   A0769               ; 030c 28 07 69
                BT   1,A02f8             ; 030f 81 e8
                
                BF   $0,A0307            ; 0311 90 f5
                
A0313:          LM                       ; 0313 16
                LR   $0,A                ; 0314 50
                LM                       ; 0315 16
                LR   $1,A                ; 0316 51
                LM                       ; 0317 16
                LR   $7,A                ; 0318 57
                LIS  $6                  ; 0319 76
                LR   $6,A                ; 031a 56
                PI   A0450               ; 031b 28 04 50
                BF   $0,A02f8            ; 031e 90 d9
                
A0320:          LISU 3                   ; 0320 63
                LISL 2                   ; 0321 6a
                LIS  $0                  ; 0322 70
                AS   (IS)                ; 0323 cc
                BT   4,A0351             ; 0324 84 2c
                
                OUTS 0                   ; 0326 b0		;RAM address bus
                INC                      ; 0327 1f
                LR   $0,A                ; 0328 50
                LR   A,(IS)-             ; 0329 4e
                AI   $0a                 ; 032a 24 0a
                LR   $1,A                ; 032c 51
                LIS  $0                  ; 032d 70
                AS   (IS)                ; 032e cc
                BT   1,A0335             ; 032f 81 05
                
                LR   A,$1                ; 0331 41
                AI   $ec                 ; 0332 24 ec
                LR   $1,A                ; 0334 51
A0335:          LIS  $1                  ; 0335 71
                LR   $7,A                ; 0336 57
                LIS  $6                  ; 0337 76
                LR   $6,A                ; 0338 56
                INS  4                   ; 0339 a4		;RAM data bus
                XI   $c0                 ; 033a 23 c0
                LR   $a,A                ; 033c 5a
                LR   A,$0                ; 033d 40
                OUTS 0                   ; 033e b0		;RAM address bus
                INS  4                   ; 033f a4		;RAM data bus
                XS   $a                  ; 0340 ea
                BF   $4,A0346            ; 0341 94 04
                
                PI   A041f               ; 0343 28 04 1f
A0346:          DS   $0                  ; 0346 30
                DS   $0                  ; 0347 30
                LR   A,$0                ; 0348 40
                OUTS 0                   ; 0349 b0		;RAM address bus
                INS  4                   ; 034a a4		;RAM data bus
                XS   $a                  ; 034b ea
                BF   $4,A0351            ; 034c 94 04
                
                PI   A041f               ; 034e 28 04 1f
A0351:          LI   $16                 ; 0351 20 16
                LR   $0,A                ; 0353 50
A0354:          LR   A,$0                ; 0354 40
                OUTS 0                   ; 0355 b0		;RAM address bus
                INS  4                   ; 0356 a4		;RAM data bus
                BT   4,A039d             ; 0357 84 45
                
                LR   $1,A                ; 0359 51
                NI   $c0                 ; 035a 21 c0
                LISU 3                   ; 035c 63
                LISL 1                   ; 035d 69
                XS   (IS)                ; 035e ec
                BF   $4,A039d            ; 035f 94 3d
                
                LIS  $7                  ; 0361 77
                NS   $1                  ; 0362 f1
                CI   $01                 ; 0363 25 01
                BT   4,A03b3             ; 0365 84 4d
                
                DCI  A061d               ; 0367 2a 06 1d
                ADC                      ; 036a 8e
                ADC                      ; 036b 8e
                ADC                      ; 036c 8e
                ADC                      ; 036d 8e
                LM                       ; 036e 16
                LR   $2,A                ; 036f 52
                LM                       ; 0370 16
                LR   $3,A                ; 0371 53
                LM                       ; 0372 16
                LR   $a,A                ; 0373 5a
A0374:          DCI  A063e               ; 0374 2a 06 3e
                LR   A,$2                ; 0377 42
                ADC                      ; 0378 8e
                LM                       ; 0379 16
                LR   $b,A                ; 037a 5b
                LR   A,$0                ; 037b 40
                LR   $1,A                ; 037c 51
A037d:          LIS  $0                  ; 037d 70
                LR   $6,A                ; 037e 56
                LR   A,$1                ; 037f 41
                AS   $b                  ; 0380 cb
                LR   $1,A                ; 0381 51
                OUTS 0                   ; 0382 b0		;RAM address bus
                INS  4                   ; 0383 a4		;RAM data bus
                BF   $4,A03a7            ; 0384 94 22
                
                LIS  $0                  ; 0386 70
                LR   $7,A                ; 0387 57
                LISU 3                   ; 0388 63
                LISL 4                   ; 0389 6c
                LR   A,(IS)              ; 038a 4c
                COM                      ; 038b 18
                LISL 0                   ; 038c 68
                AS   (IS)                ; 038d cc
                BF   $1,A0393            ; 038e 91 04
                
                PI   A0450               ; 0390 28 04 50
A0393:          LIS  $0                  ; 0393 70
                AS   $a                  ; 0394 ca
                BF   $4,A037d            ; 0395 94 e7
                
A0397:          LR   A,$2                ; 0397 42
                INC                      ; 0398 1f
                LR   $2,A                ; 0399 52
                XS   $3                  ; 039a e3
                BF   $4,A0374            ; 039b 94 d8
                
A039d:          LR   A,$0                ; 039d 40
                INC                      ; 039e 1f
                LR   $0,A                ; 039f 50
                CI   $64                 ; 03a0 25 64
                BF   $4,A0354            ; 03a2 94 b1
                
                JMP  A0405               ; 03a4 29 04 05
                
A03a7:          LISU 3                   ; 03a7 63
                LISL 1                   ; 03a8 69
                NS   (IS)                ; 03a9 fc
                BF   $4,A0397            ; 03aa 94 ec
                
                LIS  $0                  ; 03ac 70
                LR   $7,A                ; 03ad 57
                PI   A0450               ; 03ae 28 04 50
                BF   $0,A0397            ; 03b1 90 e5
                
A03b3:          DCI  A0655               ; 03b3 2a 06 55
                LIS  $0                  ; 03b6 70
                AS   $1                  ; 03b7 c1
                BT   1,A03bd             ; 03b8 81 04
                
                DCI  $0660               ; 03ba 2a 06 60
A03bd:          LM                       ; 03bd 16
                LR   $2,A                ; 03be 52
A03bf:          LR   A,$0                ; 03bf 40
                AM                       ; 03c0 88
                LR   $1,A                ; 03c1 51
                OUTS 0                   ; 03c2 b0		;RAM address bus
                LIS  $0                  ; 03c3 70
                LR   $7,A                ; 03c4 57
                LR   $6,A                ; 03c5 56
                AM                       ; 03c6 88
                LR   H,DC                ; 03c7 11
                BF   $4,A03d4            ; 03c8 94 0b
                
                INS  4                   ; 03ca a4		;RAM data bus
                BT   4,A03bf             ; 03cb 84 f3
                
                LISU 3                   ; 03cd 63
                LISL 1                   ; 03ce 69
                NS   (IS)                ; 03cf fc
                BF   $4,A03bf            ; 03d0 94 ee
                
                BF   $0,A03db            ; 03d2 90 08
                
A03d4:          BF   $1,A03f4            ; 03d4 91 1f

                INS  4                   ; 03d6 a4		;RAM data bus
                BT   4,A03db             ; 03d7 84 03
                
A03d9:          BF   $0,A039d            ; 03d9 90 c3

A03db:          LR   A,$1                ; 03db 41
                CI   $1d                 ; 03dc 25 1d
                BT   1,A03ea             ; 03de 81 0b
                
                CI   $59                 ; 03e0 25 59
                BF   $1,A03ea            ; 03e2 91 07
                
                PI   A041f               ; 03e4 28 04 1f
A03e7:          LR   DC,H                ; 03e7 10
                BF   $0,A03bf            ; 03e8 90 d6
                
A03ea:          LIS  $5                  ; 03ea 75
                LR   $7,A                ; 03eb 57
                LI   $2a                 ; 03ec 20 2a
                LR   $6,A                ; 03ee 56
                PI   A0450               ; 03ef 28 04 50
                BF   $0,A03e7            ; 03f2 90 f4
                
A03f4:          LR   A,$0                ; 03f4 40
                CM                       ; 03f5 8d
                BT   1,A03d9             ; 03f6 81 e2
                
                CM                       ; 03f8 8d
                BF   $1,A03d9            ; 03f9 91 df
                
                INS  4                   ; 03fb a4		;RAM data bus
                BF   $4,A03d9            ; 03fc 94 dc
                
                LR   A,$1                ; 03fe 41
                LR   $7,A                ; 03ff 57
                PI   A041f               ; 0400 28 04 1f
                BF   $0,A03d9            ; 0403 90 d5
                
A0405:          LIS  $0                  ; 0405 70
                AS   $8                  ; 0406 c8
                BT   4,A040c             ; 0407 84 04
                
                JMP  A00b8               ; 0409 29 00 b8
                
A040c:          LISU 4                   ; 040c 64
                LISL 6                   ; 040d 6e
                LIS  $0                  ; 040e 70
                AS   (IS)                ; 040f cc
                BF   $4,A041c            ; 0410 94 0b
                
                PI   A0756               ; 0412 28 07 56
                BT   1,A041c             ; 0415 81 06
                
                LI   $28                 ; 0417 20 28
                LISU 3                   ; 0419 63
                LISL 6                   ; 041a 6e
                LR   (IS),A              ; 041b 5c
A041c:          JMP  A055e               ; 041c 29 05 5e

A041f:          LISU 3                   ; 041f 63
                LISL 4                   ; 0420 6c
                LR   A,(IS)              ; 0421 4c
                COM                      ; 0422 18
                LISL 0                   ; 0423 68
                AS   (IS)                ; 0424 cc
                BF   $1,A0446            ; 0425 91 20
                
                LISU 4                   ; 0427 64
                LISL 4                   ; 0428 6c
                LR   A,(IS)              ; 0429 4c
                CI   $32                 ; 042a 25 32
                BT   1,A0450             ; 042c 81 23
                
                LR   A,$1                ; 042e 41
A042f:          AS   $2                  ; 042f c2
                OUTS 0                   ; 0430 b0		;RAM address bus
                INS  4                   ; 0431 a4		;RAM data bus
                NI   $07                 ; 0432 21 07
                CI   $01                 ; 0434 25 01
                BT   4,A0450             ; 0436 84 19
                
                INS  0                   ; 0438 a0		;RAM address bus
                CI   $27                 ; 0439 25 27
                BT   1,A0441             ; 043b 81 05
                
                CI   $51                 ; 043d 25 51
                BT   1,A042f             ; 043f 81 ef
                
A0441:          LIS  $3                  ; 0441 73
                AS   $6                  ; 0442 c6
                LR   $6,A                ; 0443 56
                BF   $0,A0450            ; 0444 90 0b
                
A0446:          LIS  $0                  ; 0446 70
                AS   $6                  ; 0447 c6
                BF   $4,A0450            ; 0448 94 07
                
                LR   A,$1                ; 044a 41
                OUTS 0                   ; 044b b0		;RAM address bus
                INS  4                   ; 044c a4		;RAM data bus
                BF   $4,A0450            ; 044d 94 02
                
                POP                      ; 044f 1c
                
A0450:          LR   K,P                 ; 0450 08
                LIS  $0                  ; 0451 70
                AS   $8                  ; 0452 c8
                BT   4,A0458             ; 0453 84 04
                
                JMP  A05c2               ; 0455 29 05 c2
                
A0458:          LR   A,$1                ; 0458 41
                OUTS 0                   ; 0459 b0		;RAM address bus
                INS  4                   ; 045a a4		;RAM data bus
                NI   $07                 ; 045b 21 07
                DCI  A064e               ; 045d 2a 06 4e
                ADC                      ; 0460 8e
                LISU 3                   ; 0461 63
                LISL 4                   ; 0462 6c
                LR   A,$6                ; 0463 46
                AM                       ; 0464 88
                LR   $6,A                ; 0465 56
                LR   A,(IS)              ; 0466 4c
                LISL 7                   ; 0467 6f
                XS   (IS)                ; 0468 ec
                BF   $4,A0498            ; 0469 94 2e
                
                DCI  A068f               ; 046b 2a 06 8f
                PI   A05ec               ; 046e 28 05 ec
                LR   A,$1                ; 0471 41
                LR   $4,A                ; 0472 54
                PI   A0769               ; 0473 28 07 69
                DCI  A0696               ; 0476 2a 06 96
                BF   $1,A048c            ; 0479 91 12
                
                PI   A05f9               ; 047b 28 05 f9
                LR   A,$0                ; 047e 40
                OUTS 0                   ; 047f b0		;RAM address bus
                INS  4                   ; 0480 a4		;RAM data bus
                NI   $07                 ; 0481 21 07
                DCI  A064e               ; 0483 2a 06 4e
                ADC                      ; 0486 8e
                LM                       ; 0487 16
                COM                      ; 0488 18
                INC                      ; 0489 1f
                BF   $0,A0490            ; 048a 90 05
                
A048c:          PI   A05f9               ; 048c 28 05 f9
                LIS  $0                  ; 048f 70
A0490:          LISU 4                   ; 0490 64
                LISL 0                   ; 0491 68
                AS   (IS)                ; 0492 cc
                AS   $6                  ; 0493 c6
                LR   QU,A                ; 0494 06
                JMP  A052f               ; 0495 29 05 2f
                
A0498:          LISL 4                   ; 0498 6c
                LR   A,(IS)              ; 0499 4c
                LISL 0                   ; 049a 68
                COM                      ; 049b 18
                AS   (IS)                ; 049c cc
                BT   1,A04b0             ; 049d 81 12
                
                LISU 4                   ; 049f 64
                LISL 0                   ; 04a0 68
                LR   A,(IS)              ; 04a1 4c
                AS   $6                  ; 04a2 c6
                COM                      ; 04a3 18
                INC                      ; 04a4 1f
                LISU 3                   ; 04a5 63
                LISL 6                   ; 04a6 6e
                AS   (IS)                ; 04a7 cc
                BF   $8,A04ad            ; 04a8 98 04
                
                BT   1,A04b0             ; 04aa 81 05
                
                PK                       ; 04ac 0c
                
A04ad:          BF   $1,A04b0            ; 04ad 91 02

                PK                       ; 04af 0c
                
A04b0:          DCI  A066b               ; 04b0 2a 06 6b
                PI   A05ec               ; 04b3 28 05 ec
                PI   A0703               ; 04b6 28 07 03
                DCI  A0675               ; 04b9 2a 06 75
                PI   A05ec               ; 04bc 28 05 ec
                LISU 4                   ; 04bf 64
                LISL 6                   ; 04c0 6e
                LR   A,(IS)+             ; 04c1 4d
                LR   (IS),A              ; 04c2 5c
                LISU 3                   ; 04c3 63
                LISL 4                   ; 04c4 6c
                LR   A,(IS)              ; 04c5 4c
                INC                      ; 04c6 1f
                LR   (IS)+,A             ; 04c7 5d
                LR   A,(IS)+             ; 04c8 4d
                LR   QL,A                ; 04c9 07
                LR   A,(IS)-             ; 04ca 4e
                COM                      ; 04cb 18
                INC                      ; 04cc 1f
                LR   (IS)+,A             ; 04cd 5d
                LR   A,QL                ; 04ce 03
                COM                      ; 04cf 18
                INC                      ; 04d0 1f
                LR   (IS),A              ; 04d1 5c
                LISL 4                   ; 04d2 6c
                LIS  $1                  ; 04d3 71
                XS   (IS)                ; 04d4 ec
                BF   $4,A04f4            ; 04d5 94 1e
                
                LR   A,$6                ; 04d7 46
                CI   $03                 ; 04d8 25 03
                BT   1,A04df             ; 04da 81 04
                
                INC                      ; 04dc 1f
                INC                      ; 04dd 1f
                LR   $6,A                ; 04de 56
A04df:          LISU 4                   ; 04df 64
                LISL 1                   ; 04e0 69
                LIS  $3                  ; 04e1 73
                NS   (IS)                ; 04e2 fc
                BT   4,A04e6             ; 04e3 84 02
                
                DS   $6                  ; 04e5 36
A04e6:          LISU 5                   ; 04e6 65
                LISL 3                   ; 04e7 6b
                LR   A,(IS)+             ; 04e8 4d
                XS   $0                  ; 04e9 e0
                BF   $4,A04f4            ; 04ea 94 09
                
                LR   A,(IS)              ; 04ec 4c
                XS   $1                  ; 04ed e1
                BF   $4,A04f4            ; 04ee 94 05
                
                LI   $fd                 ; 04f0 20 fd
                AS   $6                  ; 04f2 c6
                LR   $6,A                ; 04f3 56
A04f4:          LISU 4                   ; 04f4 64
                LISL 0                   ; 04f5 68
                LR   A,(IS)              ; 04f6 4c
                AS   $6                  ; 04f7 c6
                COM                      ; 04f8 18
                INC                      ; 04f9 1f
                LR   (IS),A              ; 04fa 5c
                PI   A0756               ; 04fb 28 07 56
                BF   $1,A0509            ; 04fe 91 0a
                
                PI   A06e3               ; 0500 28 06 e3
                LISL 6                   ; 0503 6e
                LI   $7d                 ; 0504 20 7d
                LR   (IS),A              ; 0506 5c
                BF   $0,A055e            ; 0507 90 56
                
A0509:          PI   A06e3               ; 0509 28 06 e3
                LISU 4                   ; 050c 64
                LISL 7                   ; 050d 6f
                DS   (IS)+               ; 050e 3d
                LISU 3                   ; 050f 63
                LR   A,(IS)              ; 0510 4c
                LISL 4                   ; 0511 6c
                XS   (IS)                ; 0512 ec
                BF   $4,A052c            ; 0513 94 18
                
                LIS  $0                  ; 0515 70
                LR   $4,A                ; 0516 54
                LISL 1                   ; 0517 69
                DCI  A069d               ; 0518 2a 06 9d
                PI   A0609               ; 051b 28 06 09
                LR   A,$4                ; 051e 44
                COM                      ; 051f 18
                LR   $4,A                ; 0520 54
                PI   A0609               ; 0521 28 06 09
                LISU 4                   ; 0524 64
                LISL 0                   ; 0525 68
                LR   A,$4                ; 0526 44
                COM                      ; 0527 18
                SL   1                   ; 0528 13
                AS   (IS)                ; 0529 cc
                LR   (IS)+,A             ; 052a 5d
                DS   (IS)                ; 052b 3c
A052c:          JMP  A02a7               ; 052c 29 02 a7

A052f:          LISU 3                   ; 052f 63
                LISL 6                   ; 0530 6e
                LR   A,QU                ; 0531 02
                COM                      ; 0532 18
                INC                      ; 0533 1f
                AS   (IS)                ; 0534 cc
                BT   4,A054e             ; 0535 84 18
                
                BF   $8,A053c            ; 0537 98 04
                
                BT   1,A053f             ; 0539 81 05
                
                PK                       ; 053b 0c
                
A053c:          BF   $1,A053f            ; 053c 91 02

                PK                       ; 053e 0c
                
A053f:          LR   A,QU                ; 053f 02
                LR   (IS),A              ; 0540 5c
                LISL 4                   ; 0541 6c
                LIS  $0                  ; 0542 70
                AS   (IS)                ; 0543 cc
                BF   $4,A054e            ; 0544 94 09
                
                LISU 5                   ; 0546 65
                LISL 0                   ; 0547 68
                LR   A,$0                ; 0548 40
                LR   (IS)+,A             ; 0549 5d
                LR   A,$1                ; 054a 41
                LR   (IS)+,A             ; 054b 5d
                LR   A,$7                ; 054c 47
                LR   (IS)+,A             ; 054d 5d
A054e:          LR   A,QU                ; 054e 02
                COM                      ; 054f 18
                INC                      ; 0550 1f
                LISU 3                   ; 0551 63
                LISL 5                   ; 0552 6d
                AS   (IS)                ; 0553 cc
                BT   4,A055e             ; 0554 84 09
                
                BF   $8,A055b            ; 0556 98 04
                
                BT   1,A055e             ; 0558 81 05
                
                PK                       ; 055a 0c
                
A055b:          BF   $1,A055e            ; 055b 91 02

                PK                       ; 055d 0c
                
A055e:          LISU 3                   ; 055e 63
                LISL 6                   ; 055f 6e
                LR   A,(IS)              ; 0560 4c
                LISL 4                   ; 0561 6c
                LIS  $0                  ; 0562 70
                AS   (IS)                ; 0563 cc
                BT   4,A0589             ; 0564 84 24
                
                DS   (IS)                ; 0566 3c
                LISL 6                   ; 0567 6e
                LR   A,(IS)-             ; 0568 4e
                COM                      ; 0569 18
                INC                      ; 056a 1f
                LR   QU,A                ; 056b 06
                LR   A,(IS)+             ; 056c 4d
                COM                      ; 056d 18
                INC                      ; 056e 1f
                LR   (IS),A              ; 056f 5c
                LISU 4                   ; 0570 64
                LISL 7                   ; 0571 6f
                LR   A,(IS)-             ; 0572 4e
                LR   (IS),A              ; 0573 5c
                DCI  A067d               ; 0574 2a 06 7d
                PI   A05f9               ; 0577 28 05 f9
                PI   A06b7               ; 057a 28 06 b7
                PI   A06e3               ; 057d 28 06 e3
                DCI  A0688               ; 0580 2a 06 88
                PI   A05f9               ; 0583 28 05 f9
                JMP  A052f               ; 0586 29 05 2f
                
A0589:          LISU 5                   ; 0589 65
                LISL 0                   ; 058a 68
                LR   A,(IS)+             ; 058b 4d
                LR   $0,A                ; 058c 50
                LR   A,(IS)+             ; 058d 4d
                LR   $1,A                ; 058e 51
                LR   A,(IS)+             ; 058f 4d
                LR   $7,A                ; 0590 57
                LR   A,$1                ; 0591 41
                LR   (IS)+,A             ; 0592 5d
                LR   A,$0                ; 0593 40
                LR   (IS)+,A             ; 0594 5d
                LISU 4                   ; 0595 64
                LISL 6                   ; 0596 6e
                LIS  $0                  ; 0597 70
                AS   (IS)                ; 0598 cc
                BT   4,A05b2             ; 0599 84 18
                
                PI   A0703               ; 059b 28 07 03
                PI   A0750               ; 059e 28 07 50
                PI   A06e3               ; 05a1 28 06 e3
                LISU 2                   ; 05a4 62
                LISL 3                   ; 05a5 6b
                LR   A,$0                ; 05a6 40
                LR   $4,A                ; 05a7 54
                PI   A0250               ; 05a8 28 02 50
                LR   A,$1                ; 05ab 41
                LR   $4,A                ; 05ac 54
                PI   A0250               ; 05ad 28 02 50
                BF   $0,A05bf            ; 05b0 90 0e
                
A05b2:          PI   A0756               ; 05b2 28 07 56
                LI   $12                 ; 05b5 20 12
                BF   $1,A05bb            ; 05b7 91 03
                
                LI   $1c                 ; 05b9 20 1c
A05bb:          LR   $0,A                ; 05bb 50
                PI   A0249               ; 05bc 28 02 49
A05bf:          JMP  A006c               ; 05bf 29 00 6c

A05c2:          LR   A,$8                ; 05c2 48
                XS   $0                  ; 05c3 e0
                BT   4,A05c7             ; 05c4 84 02
                
                PK                       ; 05c6 0c
                
A05c7:          LR   A,$9                ; 05c7 49
                XS   $1                  ; 05c8 e1
                BT   4,A05cc             ; 05c9 84 02
                
                PK                       ; 05cb 0c
                
A05cc:          PI   A0703               ; 05cc 28 07 03
                PI   A0756               ; 05cf 28 07 56
                BT   1,A05e6             ; 05d2 81 13
                
                PI   A0750               ; 05d4 28 07 50
                PI   A06e3               ; 05d7 28 06 e3
                LISU 2                   ; 05da 62
                LISL 2                   ; 05db 6a
                LIS  $0                  ; 05dc 70
                AS   (IS)                ; 05dd cc
                BT   4,A05e3             ; 05de 84 04
                
                JMP  A027c               ; 05e0 29 02 7c
                
A05e3:          JMP  A0069               ; 05e3 29 00 69

A05e6:          PI   A06b7               ; 05e6 28 06 b7
                JMP  A00b8               ; 05e9 29 00 b8
                
A05ec:          LIS  $0                  ; 05ec 70
                AM                       ; 05ed 88
                BF   $1,A05f8            ; 05ee 91 09
                
                LR   IS,A                ; 05f0 0b
                DS   $9                  ; 05f1 39
                LR   A,$9                ; 05f2 49
                OUTS 0                   ; 05f3 b0		;RAM address bus
                LR   A,(IS)              ; 05f4 4c
                OUTS 4                   ; 05f5 b4		;RAM data bus
                BF   $0,A05ec            ; 05f6 90 f5
                
A05f8:          POP                      ; 05f8 1c

A05f9:          LIS  $0                  ; 05f9 70
                OUTS 0                   ; 05fa b0		;RAM address bus
                OUTS 4                   ; 05fb b4		;RAM data bus
A05fc:          LIS  $0                  ; 05fc 70
                AM                       ; 05fd 88
                BF   $1,A05f8            ; 05fe 91 f9
                
                LR   IS,A                ; 0600 0b
                LR   A,$9                ; 0601 49
                OUTS 0                   ; 0602 b0		;RAM address bus
                INC                      ; 0603 1f
                LR   $9,A                ; 0604 59
                INS  4                   ; 0605 a4		;RAM data bus
                LR   (IS),A              ; 0606 5c
                BF   $0,A05fc            ; 0607 90 f4
                
A0609:          LIS  $0                  ; 0609 70
                AM                       ; 060a 88
                BT   4,A05f8             ; 060b 84 ec
                
                OUTS 0                   ; 060d b0		;RAM address bus
                INS  4                   ; 060e a4		;RAM data bus
                BT   4,A0609             ; 060f 84 f9
                
                NI   $07                 ; 0611 21 07
                CI   $04                 ; 0613 25 04
                BF   $1,A0609            ; 0615 91 f3
                
                INS  4                   ; 0617 a4		;RAM data bus
                NS   (IS)                ; 0618 fc
                BT   4,A061e             ; 0619 84 04
                
                LIS  $2                  ; 061b 72
                AS   $4                  ; 061c c4
A061d:          LR   $4,A                ; 061d 54
A061e:          DS   $4                  ; 061e 34
                BF   $0,A0609            ; 061f 90 e9
     
A0621:          db   $06,$08,$00,$41,$08,$10,$00,$02,$04,$08,$01,$03,$00,$04,$01,$04,$00,$08,$01,$05,$00,$08,$00,$06,$04,$06,$00,$81,$ff
A063e:          db   $01,$ff,$f6,$0a,$0b,$09,$f5,$f7,$15,$0c,$13,$08,$eb,$f4,$f8,$ed                
A064e:          db   $00,$06,$10,$12,$1a,$30,$32
A0655:          db   $0a,$0b,$00,$09,$00,$0a,$01,$14,$ff,$1e,$28,$f6,$f5,$00,$f7,$00,$f6,$01,$ec,$ff,$50,$5a
A066b:          db   $0c,$0d,$02,$03,$0a,$0b,$1a,$1b,$27,$ff
A0675:          db   $00,$01,$02,$03,$07,$20,$1d,$ff
A067d:          db   $1d,$20,$07,$03,$02,$01,$00,$27,$1b,$1a,$ff
A0688:          db   $0b,$0a,$03,$02,$0d,$0c,$ff
A068f:          db   $0c,$0d,$05,$06,$01,$04,$ff
A0696:          db   $04,$01,$06,$05,$0d,$0c,$ff
A069d:          db   $2c,$2f,$36,$39,$40,$43,$4a,$4d,$37,$38,$42,$41,$00,$17,$18,$23,$24,$1b,$1c,$5d,$5e,$55,$56,$61,$62,$00
                
A06b7:          LR   A,$0                ; 06b7 40
                OUTS 0                   ; 06b8 b0		;RAM address bus
                LR   A,$2                ; 06b9 42
                OUTS 4                   ; 06ba b4		;RAM data bus
                LR   A,$1                ; 06bb 41
                OUTS 0                   ; 06bc b0		;RAM address bus
                LR   A,$3                ; 06bd 43
                OUTS 4                   ; 06be b4		;RAM data bus
                LIS  $0                  ; 06bf 70                
                AS   $7                  ; 06c0 c7
                BT   1,A06d6             ; 06c1 81 14
                
                DCI  A07f9               ; 06c3 2a 07 f9
                ADC                      ; 06c6 8e
                LIS  $0                  ; 06c7 70
                OUTS 0                   ; 06c8 b0		;RAM address bus
                OUTS 4                   ; 06c9 b4		;RAM data bus
                LM                       ; 06ca 16
                LR   $2,A                ; 06cb 52
                LM                       ; 06cc 16
                OUTS 0                   ; 06cd b0		;RAM address bus
                INS  4                   ; 06ce a4		;RAM data bus
                LR   $3,A                ; 06cf 53
                LIS  $0                  ; 06d0 70
                OUTS 4                   ; 06d1 b4		;RAM data bus
                LR   A,$2                ; 06d2 42
                OUTS 0                   ; 06d3 b0		;RAM address bus
                LR   A,$3                ; 06d4 43
                OUTS 4                   ; 06d5 b4		;RAM data bus
A06d6:          LIS  $1                  ; 06d6 71
                XS   $7                  ; 06d7 e7
                BF   $4,A06e2            ; 06d8 94 09
                
                LISU 3                   ; 06da 63
                LISL 2                   ; 06db 6a
                LR   A,(IS)              ; 06dc 4c
                OUTS 0                   ; 06dd b0		;RAM address bus
                LR   A,$2                ; 06de 42
                XI   $c0                 ; 06df 23 c0
                OUTS 4                   ; 06e1 b4		;RAM data bus
A06e2:          POP                      ; 06e2 1c

A06e3:          LISU 3                   ; 06e3 63
                LISL 1                   ; 06e4 69
                LR   A,(IS)              ; 06e5 4c
                XI   $c0                 ; 06e6 23 c0
                LR   (IS),A              ; 06e8 5c
                POP                      ; 06e9 1c
                
A06ea:          DCI  A07b3               ; 06ea 2a 07 b3
                LISU 3                   ; 06ed 63
                LISL 3                   ; 06ee 6b
A06ef:          LIS  $0                  ; 06ef 70
                AM                       ; 06f0 88
                BF   $4,A06f4            ; 06f1 94 02
                
                POP                      ; 06f3 1c
                
A06f4:          XS   $3                  ; 06f4 e3
                BF   $4,A06ef            ; 06f5 94 f9
                
                LIS  $6                  ; 06f7 76
                ADC                      ; 06f8 8e
                LM                       ; 06f9 16
                NS   (IS)                ; 06fa fc
                XS   (IS)                ; 06fb ec
                BT   4,A0702             ; 06fc 84 05
                
                DS   $6                  ; 06fe 36
                DS   $6                  ; 06ff 36
                XS   (IS)                ; 0700 ec
                LR   (IS),A              ; 0701 5c
A0702:          POP                      ; 0702 1c

A0703:          LR   K,P                 ; 0703 08
                LIS  $0                  ; 0704 70
                OUTS 0                   ; 0705 b0		;RAM address bus
                OUTS 4                   ; 0706 b4		;RAM data bus
                LR   A,$0                ; 0707 40
                LR   $3,A                ; 0708 53
                PI   A06ea               ; 0709 28 06 ea
                LR   A,$1                ; 070c 41
                LR   $3,A                ; 070d 53
                PI   A06ea               ; 070e 28 06 ea
                LISL 2                   ; 0711 6a
                LIS  $1                  ; 0712 71
                XS   $7                  ; 0713 e7
                BF   $4,A071a            ; 0714 94 05
                
                LR   A,(IS)              ; 0716 4c
                OUTS 0                   ; 0717 b0		;RAM address bus
                LIS  $0                  ; 0718 70
                OUTS 4                   ; 0719 b4		;RAM data bus
A071a:          LIS  $0                  ; 071a 70
                LR   (IS),A              ; 071b 5c
                LR   A,$0                ; 071c 40
                OUTS 0                   ; 071d b0		;RAM address bus
                INS  4                   ; 071e a4		;RAM data bus
                LR   $2,A                ; 071f 52
                LIS  $0                  ; 0720 70
                OUTS 4                   ; 0721 b4		;RAM data bus
                LR   A,$1                ; 0722 41
                OUTS 0                   ; 0723 b0		;RAM address bus
                INS  4                   ; 0724 a4		;RAM data bus
                LR   $3,A                ; 0725 53
                LR   A,$2                ; 0726 42
                OUTS 4                   ; 0727 b4		;RAM data bus
                LR   A,$7                ; 0728 47
                CI   $05                 ; 0729 25 05
                BF   $4,A0732            ; 072b 94 06
                
                INS  4                   ; 072d a4		;RAM data bus
                OI   $05                 ; 072e 22 05
                OUTS 4                   ; 0730 b4		;RAM data bus
                PK                       ; 0731 0c
                
A0732:          CI   $ff                 ; 0732 25 ff
                BF   $1,A0749            ; 0734 91 14
                
                DCI  A07f9               ; 0736 2a 07 f9
                ADC                      ; 0739 8e
                LIS  $0                  ; 073a 70
                OUTS 0                   ; 073b b0		;RAM address bus
                OUTS 4                   ; 073c b4		;RAM data bus
                LR   A,$1                ; 073d 41
                LM                       ; 073e 16
                OUTS 0                   ; 073f b0		;RAM address bus
                INS  4                   ; 0740 a4		;RAM data bus
                LR   QL,A                ; 0741 07
                LIS  $0                  ; 0742 70
                OUTS 4                   ; 0743 b4		;RAM data bus
                LM                       ; 0744 16
                OUTS 0                   ; 0745 b0		;RAM address bus
                LR   A,QL                ; 0746 03
                OUTS 4                   ; 0747 b4		;RAM data bus
                PK                       ; 0748 0c
                
A0749:          CI   $02                 ; 0749 25 02
                BT   1,A074f             ; 074b 81 03
                
                LISL 2                   ; 074d 6a
                LR   (IS),A              ; 074e 5c
A074f:          PK                       ; 074f 0c

A0750:          LISU 4                   ; 0750 64
                LISL 4                   ; 0751 6c
                LR   A,(IS)              ; 0752 4c
                INC                      ; 0753 1f
                LR   (IS),A              ; 0754 5c
                POP                      ; 0755 1c
                
A0756:          LIS  $0                  ; 0756 70
                OUTS 0                   ; 0757 b0		;RAM address bus
                OUTS 4                   ; 0758 b4		;RAM data bus
                LISU 3                   ; 0759 63
                LISL 1                   ; 075a 69
                LIS  $6                  ; 075b 76
                AS   (IS)                ; 075c cc
                LR   $4,A                ; 075d 54
A075e:          INS  0                   ; 075e a0		;RAM address bus
                INC                      ; 075f 1f
                BF   $1,A07a7            ; 0760 91 46
                
                OUTS 0                   ; 0762 b0		;RAM address bus
                INS  4                   ; 0763 a4		;RAM data bus
                XS   $4                  ; 0764 e4
                BF   $4,A075e            ; 0765 94 f8
                
                INS  0                   ; 0767 a0		;RAM address bus
                LR   $4,A                ; 0768 54
A0769:          LIS  $0                  ; 0769 70
                OUTS 0                   ; 076a b0		;RAM address bus
                OUTS 4                   ; 076b b4		;RAM data bus
                LISU 4                   ; 076c 64
                LISL 2                   ; 076d 6a
                LR   A,$a                ; 076e 4a
                LR   (IS)+,A             ; 076f 5d
                LR   A,$b                ; 0770 4b
                LR   (IS)+,A             ; 0771 5d
                LR   H,DC                ; 0772 11
                DCI  A0621               ; 0773 2a 06 21
A0776:          LIS  $0                  ; 0776 70
                AM                       ; 0777 88
                BF   $1,A07a9            ; 0778 91 30
                
                LR   KU,A                ; 077a 04
                LM                       ; 077b 16
                LR   $1,A                ; 077c 51
                LM                       ; 077d 16
                LR   KL,A                ; 077e 05
                LISU 3                   ; 077f 63
                LISL 1                   ; 0780 69
                LR   A,(IS)              ; 0781 4c
                XI   $c0                 ; 0782 23 c0
                OM                       ; 0784 8b
                LR   $5,A                ; 0785 55
                LR   Q,DC                ; 0786 0e
A0787:          DCI  A063e               ; 0787 2a 06 3e
                LR   A,KU                ; 078a 00
                ADC                      ; 078b 8e
                LM                       ; 078c 16
                LR   $6,A                ; 078d 56
                LR   A,$4                ; 078e 44
                OUTS 0                   ; 078f b0		;RAM address bus
A0790:          INS  0                   ; 0790 a0		;RAM address bus
                AS   $6                  ; 0791 c6
                OUTS 0                   ; 0792 b0		;RAM address bus
                INS  4                   ; 0793 a4		;RAM data bus
                BF   $4,A079b            ; 0794 94 06
                
                LR   A,KL                ; 0796 01
                CI   $00                 ; 0797 25 00
                BF   $4,A0790            ; 0799 94 f6
                
A079b:          XS   $5                  ; 079b e5
                BT   4,A07a7             ; 079c 84 0a
                
                LR   A,KU                ; 079e 00
                INC                      ; 079f 1f
                LR   KU,A                ; 07a0 04
                XS   $1                  ; 07a1 e1
                BF   $4,A0787            ; 07a2 94 e4
                
                LR   DC,Q                ; 07a4 0f
                BF   $0,A0776            ; 07a5 90 d0
                
A07a7:          LIS  $1                  ; 07a7 71
                INC                      ; 07a8 1f
A07a9:          LR   A,$9                ; 07a9 49
                LR   $1,A                ; 07aa 51
                LR   DC,H                ; 07ab 10
                LISU 4                   ; 07ac 64
                LISL 3                   ; 07ad 6b
                LR   A,(IS)-             ; 07ae 4e
                LR   $b,A                ; 07af 5b
                LR   A,(IS)-             ; 07b0 4e
                LR   $a,A                ; 07b1 5a
                POP                      ; 07b2 1c
                
A07b3:			db   $16,$1a,$1d,$5c,$60,$63,$00,$0d,$0c,$0e,$07,$03,$0b

A07c0:          db   $01,$0a,$1b,$1c,$00,$1a,$1b,$1c,$00,$1a,$1c,$f9,$02,$03,$19,$18
                db   $17,$00,$1a,$19,$18,$00,$1a,$18,$fb
                
A07d9:                
                db	 $04,$0a,$61,$62,$00,$60,$61,$62
                db   $00,$60,$62,$fd,$08,$03,$5f,$5e
                db   $5d,$00,$60,$5f,$5e,$00,$60,$5e
                db   $ff
                db   $1d,$1b,$16,$19,$63,$61,$5c
A07f9:          db   $5f
                db   $00,$00,$00,$00,$00,$00
                
